# coding: utf-8

"""
    Alfresco Content Services REST API

    **Core API**  Provides access to the core features of Alfresco Content Services.   # noqa: E501

    OpenAPI spec version: 1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


import pprint
import re  # noqa: F401

import six

from alfresco_core_api_client.configuration import Configuration


class Category(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """

    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'str',
        'name': 'str',
        'parent_id': 'str',
        'has_children': 'bool',
        'count': 'float',
        'path': 'str'
    }

    attribute_map = {
        'id': 'id',
        'name': 'name',
        'parent_id': 'parentId',
        'has_children': 'hasChildren',
        'count': 'count',
        'path': 'path'
    }

    def __init__(self, id=None, name=None, parent_id=None, has_children=None, count=None, path=None, _configuration=None):  # noqa: E501
        """Category - a model defined in Swagger"""  # noqa: E501
        if _configuration is None:
            _configuration = Configuration()
        self._configuration = _configuration

        self._id = None
        self._name = None
        self._parent_id = None
        self._has_children = None
        self._count = None
        self._path = None
        self.discriminator = None

        self.id = id
        self.name = name
        if parent_id is not None:
            self.parent_id = parent_id
        if has_children is not None:
            self.has_children = has_children
        if count is not None:
            self.count = count
        if path is not None:
            self.path = path

    @property
    def id(self):
        """Gets the id of this Category.  # noqa: E501

        The identifier for the category.  # noqa: E501

        :return: The id of this Category.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this Category.

        The identifier for the category.  # noqa: E501

        :param id: The id of this Category.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")  # noqa: E501

        self._id = id

    @property
    def name(self):
        """Gets the name of this Category.  # noqa: E501

        The name of the category.  This must be unique within the parent category.   # noqa: E501

        :return: The name of this Category.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this Category.

        The name of the category.  This must be unique within the parent category.   # noqa: E501

        :param name: The name of this Category.  # noqa: E501
        :type: str
        """
        if self._configuration.client_side_validation and name is None:
            raise ValueError("Invalid value for `name`, must not be `None`")  # noqa: E501

        self._name = name

    @property
    def parent_id(self):
        """Gets the parent_id of this Category.  # noqa: E501

        The id of the parent category (or -root- if this is a top level category).  # noqa: E501

        :return: The parent_id of this Category.  # noqa: E501
        :rtype: str
        """
        return self._parent_id

    @parent_id.setter
    def parent_id(self, parent_id):
        """Sets the parent_id of this Category.

        The id of the parent category (or -root- if this is a top level category).  # noqa: E501

        :param parent_id: The parent_id of this Category.  # noqa: E501
        :type: str
        """

        self._parent_id = parent_id

    @property
    def has_children(self):
        """Gets the has_children of this Category.  # noqa: E501

        True if the category has at least one child category.  # noqa: E501

        :return: The has_children of this Category.  # noqa: E501
        :rtype: bool
        """
        return self._has_children

    @has_children.setter
    def has_children(self, has_children):
        """Sets the has_children of this Category.

        True if the category has at least one child category.  # noqa: E501

        :param has_children: The has_children of this Category.  # noqa: E501
        :type: bool
        """

        self._has_children = has_children

    @property
    def count(self):
        """Gets the count of this Category.  # noqa: E501

        The number of nodes that are assigned to this category.  # noqa: E501

        :return: The count of this Category.  # noqa: E501
        :rtype: float
        """
        return self._count

    @count.setter
    def count(self, count):
        """Sets the count of this Category.

        The number of nodes that are assigned to this category.  # noqa: E501

        :param count: The count of this Category.  # noqa: E501
        :type: float
        """

        self._count = count

    @property
    def path(self):
        """Gets the path of this Category.  # noqa: E501

        The path to this category.  # noqa: E501

        :return: The path of this Category.  # noqa: E501
        :rtype: str
        """
        return self._path

    @path.setter
    def path(self, path):
        """Sets the path of this Category.

        The path to this category.  # noqa: E501

        :param path: The path of this Category.  # noqa: E501
        :type: str
        """

        self._path = path

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(Category, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Category):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Category):
            return True

        return self.to_dict() != other.to_dict()
